"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dynamicFormItemOptions = void 0;
const IFormBuilderListConfig_1 = require("../../formbuilder/components/config/IFormBuilderListConfig");
const MyDynamicFormItem_1 = require("./MyDynamicFormItem");
exports.dynamicFormItemOptions = {
    itemType: MyDynamicFormItem_1.MyDynamicFormItem,
    item: [
        { id: "c39c56ae-35c5-4f43-8304-751101f223c0", name: "RemoveAccessor", key: "render1" },
        { id: "89923037-597e-496e-954e-8e5ed0ce9a40", name: "GetWhiteList", key: "render2" },
        { id: "89923037-597e-496e-954e-8e5ed0ce9a40", name: "GetWhiteList", key: "unknownrender" }
    ],
    spinnerProps: { timeout: 3000 },
    listProps: {
        onItemChange: item => console.log(item),
        config: {
            itemIdentifier: item => item.id,
            multiSelect: true,
            onItemsChange: items => console.log("FROM OUTSIDE", items),
            shimmerLines: 20
        },
        columnConfig: {
            columnOrder: ["id", "key", "name"]
        },
        editorConfig: {
            title: item => `This form is rendered based on the selected item and the dynamic key`,
            description: "Here's a little description for ya'",
            type: IFormBuilderListConfig_1.FormBuilderListEditorType.Panel,
            dynamicForm: {
                dynamicKey: (item) => item.key
            }
        },
        searchConfig: {
            searchEnabled: true,
            searchPlaceHolder: "Type here to filter items..",
            searchableFields: ["name"]
        }
    }
};
//# sourceMappingURL=DynamicFormItemOptions.js.map