"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnotherFormItemSchemaProvider = void 0;
const ISchemaProvider_1 = require("../../formbuilder/models/schema/ISchemaProvider");
const ValidationEventType_1 = require("../../formbuilder/models/validation/ValidationEventType");
const ValidationMark_1 = require("../../formbuilder/models/validation/ValidationMark");
const PropertyOptionsFactory_1 = require("../../formbuilder/utils/PropertyOptionsFactory");
const AnotherFormItem_1 = require("./AnotherFormItem");
class AnotherFormItemSchemaProvider extends ISchemaProvider_1.SchemaProvider {
    constructor() {
        super(...arguments);
        this.key = "AnotherFormItem";
        this.itemType = () => AnotherFormItem_1.AnotherFormItem;
        this.getSchema = () => __awaiter(this, void 0, void 0, function* () {
            const schema = {
                options: {
                    validation: {
                        ignoreValidation: false,
                        validationRules: {
                            name: { id: "namelength", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => { var _a, _b; return ((_b = (_a = item.name) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 3; }, validationMessage: "Your name must be over 3 characters", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                        }
                    },
                    properties: {
                        name: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This name", group: "groupOne", config: { resizable: true } }),
                        awesome: PropertyOptionsFactory_1.propertyOptionsFactory.booleanPropertyOption({ displayName: "Are you awesome, sir?", group: "groupTwo", config: { asToggle: false, textIfTrue: "Si senor", textIfFalse: "Nopes, not really" } })
                    }
                }
            };
            return schema;
        });
    }
}
exports.AnotherFormItemSchemaProvider = AnotherFormItemSchemaProvider;
//# sourceMappingURL=AnotherFormItemSchemaProvider.js.map