"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyFormItemCustomPropRenderSchemaProvider = void 0;
const ISchemaProvider_1 = require("../../formbuilder/models/schema/ISchemaProvider");
const PropertyOptionsFactory_1 = require("../../formbuilder/utils/PropertyOptionsFactory");
const ValidationEventType_1 = require("../../formbuilder/models/validation/ValidationEventType");
const ValidationMark_1 = require("../../formbuilder/models/validation/ValidationMark");
const MyFormItemCustomPropRender_1 = require("./MyFormItemCustomPropRender");
const MyCustomComponent_1 = __importDefault(require("./MyCustomComponent"));
class MyFormItemCustomPropRenderSchemaProvider extends ISchemaProvider_1.SchemaProvider {
    constructor() {
        super(...arguments);
        this.key = "MyFormItemCustomPropRender";
        this.itemType = () => MyFormItemCustomPropRender_1.MyFormItemCustomPropRender;
        this.getSchema = () => __awaiter(this, void 0, void 0, function* () {
            var schema = {
                options: {
                    validation: {
                        validationRules: {
                            name: { id: "mustbeesben", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => item.name === "Esben", validationMessage: "Your name must be 'Esben'", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                            age: { id: "lessthanforthy", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => { var _a; return ((_a = item.age) !== null && _a !== void 0 ? _a : 0) < 40; }, validationMessage: "You must be less than 40 years old", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                        }
                    },
                    properties: {
                        name: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This name", config: { resizable: true }, description: "This is an explanation of what this property does.." }),
                        age: PropertyOptionsFactory_1.propertyOptionsFactory.numberPropertyOption({ displayName: "This age", hideLabel: true, config: { allowNegativeNumbers: true } }),
                        custom: PropertyOptionsFactory_1.propertyOptionsFactory.customComponentPropertyOption({ displayName: "This is rendered by a custom component", config: { component: MyCustomComponent_1.default, test: "This is a static variable passed down from the prop config" } }),
                    }
                }
            };
            return schema;
        });
    }
}
exports.MyFormItemCustomPropRenderSchemaProvider = MyFormItemCustomPropRenderSchemaProvider;
//# sourceMappingURL=MyFormItemCustomPropRenderSchemaProvider.js.map